/******************************************************************************/
/*
	LinkList.cpp
	Created Oct, 2001
	Modified May, 2002
*/
/******************************************************************************/
#include <stdio.h>
#include "const.h"
#include "xstats.h"
#include "LinkList.h"
#include "xmenus.h"

#ifdef PREALLOCATE
#include "LinkListGlobal.h"
#endif
/******************************************************************************/
LinkList::LinkList(void)
{
	first=NULL;
	last=NULL;
	nLinkListItems=0;

/*
#ifdef PREALLOCATE
	myLLChunk=numLLChunks;
	lLChunk[myLLChunk].numGlobalLLNode=0;	// So far we have used 0 nodes
	numLLChunks++;
	if (numLLChunks>=NLINKLISTS) {
		put_error("Error:Too many simultaneous LinkLists");
	}
#endif
*/

}
/******************************************************************************/
// Free all the items Note:Client is responsible for deleting all of the keys
// This deletes all nodes from all linklists
LinkList::~LinkList(void)
{

#ifdef PREALLOCATE
	// 	numLLChunks--;	// Since we dont need it
	nLinkListItems=0;
	numGlobalLLNodes=0;	// Destroy all nodes
#else 
	LinkListItem *current,*next;

	next=first;
	while(FOREVER) {
		current=next;
		if (current==NULL) break;
		next=current->next;
		delete current;
	}
#endif
}
/******************************************************************************/
LinkListItem *LinkList::newItem(void)
{
	LinkListItem *item;

#ifdef PREALLOCATE
	if (numGlobalLLNodes>=NLLNODES) {
		put_error("Error:Too many LinkList nodes allocated");
		item=NULL;
	}
	else {
		item=(&(globalLLNode[numGlobalLLNodes]));
		numGlobalLLNodes++;
	}
	/*
	item=(&(lLChunk[myLLChunk].globalLLNode[lLChunk[myLLChunk].numGlobalLLNode]));
	lLChunk[myLLChunk].numGlobalLLNode++;
	if (lLChunk[myLLChunk].numGlobalLLNode>NLLNODES) {
		put_error("Error:Too many nodes in LinkList");
	}
	*/
#else 
	item=new LinkListItem;
#endif
	return(item);

}
/******************************************************************************/
void LinkList::appendKey(void *key)
{
	LinkListItem *item=newItem();

	if (last==NULL) first=item;
	else last->next=item;

	item->prev=last;
	item->next=NULL;
	item->key=key;

	last=item;
	nLinkListItems++;
}
/******************************************************************************/
void LinkList::push_back(void *key)
{
	appendKey(key);
}
/******************************************************************************/
void LinkList::prependKey(void *key)
{
	LinkListItem *item=newItem();

	if (first==NULL) last=item;
	else first->prev=item;

	item->next=first;
	item->prev=NULL;
	item->key=key;
	first=item;
	nLinkListItems++;
}
/******************************************************************************/
void LinkList::deleteItem(LinkListItem *item)
{
	LinkListItem *prev,*next;

	if (first==item) first=item->next;
	if (last==item) last=item->prev;

	prev=item->prev;
	next=item->next;

	if (prev!=NULL) prev->next=next;
	if (next!=NULL) next->prev=prev;

#ifdef PREALLOCATE
#else 
	delete item;
#endif

	nLinkListItems--;
}
/******************************************************************************/
LinkListItem *LinkList::getFirst(void)
{
	return(first);
}
/******************************************************************************/
LinkListItem *LinkList::getLast(void)
{
	return(first);
}
/******************************************************************************/
int LinkList::getNumItems(void)
{
	return(nLinkListItems);
}
/******************************************************************************/



