/*********************************************************/
/*
	Path.h
	Written by Matthew Maxel
	Created March 4, 2002
*/
/*********************************************************/
#ifndef Path_h
#define Path_h
/*********************************************************/
#include <iostream>
#include <string>
#include <sstream>
class Path
{
	friend std::istream &operator>>(std::istream&, Path&);
	friend std::ostream &operator<<(std::ostream&, const Path &p);
public:
	int nList;		// Number of in list in the path
	int *list;      // List of edges 
	double cost;	// Cost of path

	Path(void);			// No size
	Path(int size);		// Preallocate a certain size
	Path(const Path& p); // Copy constructor
	~Path(void);

	Path operator+(const Path& p);
	int operator==(Path *path);
	int operator!=(Path *path);
	int operator==(const Path &path);
	int operator!=(const Path &path);
	Path &operator=(const Path& p);
	void setSize(int n);
	void freeList(void);

	int merge(int edge0, double cost0, Path *path2, Path *pathOut);
	int check_for_duplicate_paths(Path *paths, int n);
	void pushFront(int itemIn, double itemCost, Path &out);
};
const Path NULLPATH(0);
/*********************************************************/
#endif
/*********************************************************/
