/******************************************************************************/
/*
	Time.cpp
	Written by Matthew Maxel
	Created March 4, 2002
*/
/****************************************************************************/
#include <time.h>
//#include <sys/timeb.h>
#include <iostream>
#include <string>
#include <sstream>
#include "Time.h"
#include "ret.h"
#include "const.h"
#include <iomanip>
#include<stdio.h>

using std::setw;
using std::setfill;
/****************************************************************************/
Time::Time(void) 
{
	sec=0;
	usec=0;
}
/******************************************************************************/
Time::Time(long secIn, long usecIn) 
{
	sec=secIn;
	usec=usecIn;
}
/******************************************************************************/
Time::Time(long msec) 
{
	sec=msec/1000;
	usec=(msec%1000)*1000;
}
/******************************************************************************/
Time::Time(const Time& p)
{
	(*this)=p;
}
/******************************************************************************/
Time &Time::operator=(const Time& t)
{
	sec=t.sec;
	usec=t.usec;
	return(*this);
}
/******************************************************************************/
Time::~Time(void)
{
}
/******************************************************************************/
Time Time::operator+(const Time& t)
{
	Time tOut,tmp=t;

	normalize();
	tmp.normalize();
	// Check for overflow/underflow ???
	tOut.sec=sec+tmp.sec;
	tOut.usec=usec+tmp.usec;
	tOut.normalize();
	return tOut;
}
/******************************************************************************/
int Time::operator==(Time *t)
{
	if (sec==t->sec && usec==t->usec) return(TRUE);
	else return(FALSE);
}
/******************************************************************************/
void Time::setCurrent(void)
{
   // struct timeb t0;
    //_ftime((struct _timeb *)&t0);
	//sec=t0.time;
	//usec=(long)(t0.millitm*1000L);
}
/******************************************************************************/
void Time::normalize(void)
{
	long absMicroSeconds;

	// Make sure that abs(t.usec)<10000000
	if (usec>1000000) {
		sec+=((usec)/1000000);
		usec=((usec)%1000000);
	}
	if (usec<(-1000000)) {
		//absMicroSeconds=abs(usec);
                if(usec>=0)absMicroSeconds=usec;
                else absMicroSeconds=-usec;
		sec-=(absMicroSeconds/1000000);
		usec=(-absMicroSeconds%1000000);
	}

	// Make sure both components have the same sign
	if (sec>0 && usec<0) {
		sec--;
		usec+=1000000;
	}
	if (sec<0 && usec>0) {
		sec++;
		usec-=1000000;
	}
}
/******************************************************************************/
Time Time::operator-(const Time& t)
{
	Time tOut,tmp=t;

	normalize();
	tmp.normalize();

	// Check for overflow/underflow ???
	tOut.sec=sec-tmp.sec;
	tOut.usec=usec-tmp.usec;
	tOut.normalize();

    return tOut;
}
/******************************************************************************/
std::ostream &operator<<(std::ostream &output, const Time &t)
{
	output << 
		(t.sec%86400)/3600 << ":" << 
		(t.sec%3600)/60 << ":" <<
		(t.sec%60) << "." << 
		setw(3) << setfill('0') << (t.usec/1000);
	return(output);
}
/******************************************************************************/
int sprintf_time(char *msg, unsigned long sec, unsigned long usec)
{
	sprintf(msg,"%02d:%02d:%02d.%03d",
		(sec%86400)/3600,
		(sec%3600)/60,
		(sec%60),
		usec/1000);
	return(OK);
}
/******************************************************************************/
int sprintf_yeartime(char *msg, unsigned long sec, unsigned long usec)
{
	sprintf(msg,"%3d %02d:%02d:%02d.%03d",
		1+sec/86400,
		(sec%86400)/3600,
		(sec%3600)/60,
		(sec%60),
		usec/1000);
	return(OK);
}
/******************************************************************************/
int sprintf_short_time(char *msg, unsigned long sec)
{
	int hr,mn,sc;
	hr=(sec%86400L)/3600;
	mn=(sec%3600)/60;
	sc=(sec%60);
	sprintf(msg,"%02d:%02d:%02d",hr,mn,sc);
	return(OK);
}
/******************************************************************************/
