/*********************************************************/
/*
	Time.h
	Written by Matthew Maxel
	Created March 4, 2002
*/
/*********************************************************/
#ifndef Time_h
#define Time_h
/*********************************************************/
#include <iostream>
#include <string>
#include <sstream>
class Time
{
	friend std::istream &operator>>(std::istream&, Time&);
	friend std::ostream &operator<<(std::ostream&, const Time &p);
public:
	long sec;
	long usec;
	
	Time(void);			
	Time(long msec);
	Time(long sec, long usec);
	Time(const Time& t); 
	~Time(void);

	Time operator+(const Time& t);
	Time operator-(const Time& t);
	int operator==(Time *Time);
	Time& operator=(const Time& t);//Time &Time::operator=(const Time& t);
	void setCurrent(void);//void Time::setCurrent(void);
	void normalize(void);//void Time::normalize(void);
};
/*********************************************************/
#endif
/*********************************************************/
