/****************************************************************************/
#include <float.h>
#include <stdlib.h>
#include <memory.h>
#include "ret.h"
#include "types.h"
#include "const.h"
/***************************************************************************/
double det3pt(double x1, double y1, double x2, double y2, double x3, double y3)
{
	return(x2*y3+x1*y2+y1*x3-x2*y1-x3*y2-x1*y3);
}
/***************************************************************************/
double det3pts(xyz_pos p1, xyz_pos p2, xyz_pos p3)
{
	return(p2.x*p3.y+p1.x*p2.y+p1.y*p3.x-p2.x*p1.y-p3.x*p2.y-p1.x*p3.y);
}
/***************************************************************************/
byte tmp[128];
/***************************************************************************/
void quick_sort(xyz_pos a[], int l, int r)
{
    static double pivot;
    static int j;
    int i;
	xyz_pos tmp;

    if (r>l) {
        pivot=a[l].x; 
		i=l; 
		j=r;
		while(FOREVER) {
            while(FOREVER) {
				if (a[i].x>pivot) break;
				i++;
				if (i>j) break;
			}
            while(FOREVER) {
				if (a[j].x<=pivot) break;
				j--;
				if (i>j) break;
			}
            if(i>=j) break;
			tmp=a[i];
			a[i]=a[j];
			a[j]=tmp;
        }
		tmp=a[j];
		a[j]=a[l];
		a[l]=tmp;
        quick_sort(a,l,j-1);
        quick_sort(a,j+1,r);
    }
}
/***************************************************************************/
void quick_sort_y(xyz_pos a[], int l, int r)
{
    static double pivot;
    static int j;
    int i;
	xyz_pos tmp;

    if (r>l) {
        pivot=a[l].y; 
		i=l; 
		j=r;
		while(FOREVER) {
            while(FOREVER) {
				if (a[i].y>pivot) break;
				i++;
				if (i>j) break;
			}
            while(FOREVER) {
				if (a[j].y<=pivot) break;
				j--;
				if (i>j) break;
			}
            if(i>=j) break;
			tmp=a[i];
			a[i]=a[j];
			a[j]=tmp;
        }
		tmp=a[j];
		a[j]=a[l];
		a[l]=tmp;
        quick_sort_y(a,l,j-1);
        quick_sort_y(a,j+1,r);
    }
}
/***************************************************************************/
void generic_quick_sort(void *list, int l, int r, int size, int (*cmp)(void *, void *))
{
    int i,j,n;
	void *pivot;
	byte *a;

	a=(byte *)list;
	//tmp=malloc(size);
    if (r>l) {
        pivot=(a+l*size); 
		i=l+1; 
		j=r;
		while(FOREVER) {
            while(FOREVER) {
				n=cmp(a+i*size,pivot);
				if (n==2) break;
				i++;
				if (i>j) break;
			}
            while(FOREVER) {
				n=cmp(a+j*size,pivot);
				if (n!=2) break;
				j--;
				if (i>j) break;
			}
            if(i>=j) break;
			// Swap	something of size
			memcpy(tmp,a+i*size,size);
			memcpy(a+i*size,a+j*size,size);
			memcpy(a+j*size,tmp,size);
        }

		// Swap	something of size
		memcpy(tmp,a+j*size,size);
		memcpy(a+j*size,a+l*size,size);
		memcpy(a+l*size,tmp,size);
        generic_quick_sort(a,l,j-1,size,cmp);
        generic_quick_sort(a,j+1,r,size,cmp);
    }
	//free(tmp);
}
/***************************************************************************/
