/***************************************************************************/
/* Pos routines */
/***************************************************************************/
#ifndef xpos_h
#define xpos_h 1
/***************************************************************************/
/* Position parameters */
struct pos_format {
    double lat0;
    double lon0;
    double rad0;
};
extern struct pos_format pos;
extern double xf,yf;
extern double rx0,ry0;
/***************************************************************************/
int init_pos(void);
void geo_to_pix(double lat, double lon, int *px, int *py);
void pix_to_geo(int px, int py, double *lat, double *lon);
void xyz_to_geo(double x, double y, double *lat, double *lon);
void geo_to_xyz(double lat, double lon, double *y, double *x);
void xyz_to_pix(double x, double y, int *px, int *py);
void pix_to_xyz(int px, int py, double *x, double *y);
void center_pos(double *lat, double *lon);
void set_pos(double lat, double lon);
void set_pos_radius(double rad);
int query_pos(double *lat, double *lon, double *rad);
int update_pos(void);
int mask_to_map(int mask);
int map_to_mask(int *mask);
short get_elv(double lat, double lon);
int get_elev(double lat, double lon, double *elv);
int rbe_to_xyz(double rng, double brg, double el, double *x, double *y, double *z);
int xyz_to_rbe(double x, double y, double z, double *rng, double *brg, double *el);
void geo3_to_pix(double lat, double lon, double alt, int *px, int *py);
void pix_to_geo3(int px, int py, double *lat, double *lon, double *alt);
void translate_pt(double *lat, double *lon, double dx, double dy);
void scale_pt(double *lat, double *lon, double xr, double yr, double sx, double sy);
void rotate_pt(double *lat, double *lon, double xr, double yr, double s, double c);
int latlon_to_rngbrg(double lat1, double lon1,
	double lat2, double lon2, double *rng, double *brg);
/***************************************************************************/
#endif
/***************************************************************************/
